diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/Sender2.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/Sender2.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/Sender2.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/Sender2.java	2017-07-30 02:57:15.162620000 +0900
@@ -0,0 +1,291 @@
+package com.android.server.remote;
+
+import java.io.IOException;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.net.InetAddress;
+import java.net.Socket;
+import java.net.UnknownHostException;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
+import android.content.Context;
+import android.graphics.Point;
+import android.location.Location;
+import android.service.devicemanagement.Device;
+import android.service.remote.AppendingObjectOutputStream;
+import android.service.remote.RemoteRequest;
+import android.service.remote.SdPackage;
+import android.util.Log;
+import android.util.SparseArray;
+import android.view.Display;
+import android.view.MotionEvent;
+import android.view.WindowManager;
+
+
+public class Sender2 implements Runnable
+{
+	private static final String TAG = "RemoteService_Sender2";
+    private static final int SERVERPORT = 55555;
+
+	private static final int DATASERVERPORT = 33333;
+	
+    private ArrayList<String> connectedDevices;
+    private HashMap<String, AppendingObjectOutputStream> deviceToOutput;
+    private SparseArray<ArrayList<AppendingObjectOutputStream>> resourceToOutput;
+
+    
+    private int Xdefault;
+	private int Ydefault;
+	
+	public Sender2(Context context)
+	{
+
+		connectedDevices = new ArrayList<String>();
+		deviceToOutput = new HashMap<String, AppendingObjectOutputStream>();
+		resourceToOutput = new SparseArray<ArrayList<AppendingObjectOutputStream>>();
+
+		
+		WindowManager wm = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
+		Display display = wm.getDefaultDisplay();
+		Point size = new Point();
+		display.getSize(size);
+		
+		Xdefault = size.x;
+		Ydefault = size.y;
+	}
+	
+	// for resource request
+	public boolean connectToRemoteDevice(Device device)
+	{
+		try 
+		{
+			InetAddress deviceAddr;
+			Socket socketToDevice;
+			AppendingObjectOutputStream outToDevice;
+	    
+			deviceAddr = InetAddress.getByName(device.ipaddress);
+	        socketToDevice = new Socket(deviceAddr, SERVERPORT);
+			//17.01.29
+			socketToDevice.setTcpNoDelay(false);
+			socketToDevice.setKeepAlive(false);
+			socketToDevice.setSoTimeout(0);
+			/*
+			socketToDevice.setTcpNoDelay(true);
+	        socketToDevice.setKeepAlive(true);
+	        socketToDevice.setSoTimeout(0);
+			*/
+	        // serverIPs.add(serverAddr.getHostAddress());
+
+	        
+	        ObjectOutputStream out = new ObjectOutputStream(socketToDevice
+	                .getOutputStream());
+	        ObjectInputStream in = new ObjectInputStream(socketToDevice.getInputStream());
+	
+	        out.writeObject(device.askedResources);
+	        int[] responseFromServer = (int[])in.readObject();
+	
+	        if (responseFromServer.length > 0)
+	        {
+	            Log.d(TAG, "Successfully connected to: " + deviceAddr
+	            		+ "allowed: " + responseFromServer.toString());
+	            RemoteService.isConnectedToServer = true;
+	            outToDevice = new AppendingObjectOutputStream(socketToDevice.getOutputStream());
+	            
+	            connectedDevices.add(device.ipaddress);
+	            RemoteService.deviceToSocket.put(device.ipaddress, socketToDevice);
+	            deviceToOutput.put(device.ipaddress, outToDevice);
+	        }
+	        else
+	        	socketToDevice.close();
+        
+		} catch (UnknownHostException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        } catch (IOException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        } catch (ClassNotFoundException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        }
+		
+		return true;
+	}
+	
+	// for communication
+	public boolean connectToRemoteDevice(String deviceIP)
+	{
+		try 
+		{
+			InetAddress deviceAddr;
+			Socket socketToDevice;
+			AppendingObjectOutputStream outToDevice;
+	    
+			deviceAddr = InetAddress.getByName(deviceIP);
+	        socketToDevice = new Socket(deviceAddr, SERVERPORT);
+	        socketToDevice.setTcpNoDelay(true);
+	        socketToDevice.setKeepAlive(true);
+	        socketToDevice.setSoTimeout(0);
+	        // serverIPs.add(serverAddr.getHostAddress());
+	        
+	        ObjectOutputStream out = new ObjectOutputStream(socketToDevice
+	                .getOutputStream());
+	        ObjectInputStream in = new ObjectInputStream(socketToDevice.getInputStream());
+	
+	        out.writeObject("Hello");
+			Log.d(TAG, "SBJJJJJJJJJJJJJJJJJ at Sender2");
+	        String responseFromServer = in.readObject().toString();
+			Log.d(TAG, "SBJJJJJJJJJJJJJJJJJ at Sender2");
+	
+	        if (responseFromServer.equals("Gooooood"))
+	        {
+	            Log.d(TAG, "Successfully connected to: " + deviceAddr);
+	            RemoteService.isConnectedToServer = true;
+	            outToDevice = new AppendingObjectOutputStream(socketToDevice.getOutputStream());
+	            
+	            connectedDevices.add(deviceIP);
+	            RemoteService.deviceToSocket.put(deviceIP, socketToDevice);
+	            deviceToOutput.put(deviceIP, outToDevice);
+	        }
+	        else
+	        	socketToDevice.close();
+        
+		} catch (UnknownHostException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        } catch (IOException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        } catch (ClassNotFoundException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        }
+		
+		return true;
+	}
+	
+	public boolean connectToRemoteDevices(List<Device> devices)
+	{
+		for(Device device : devices)
+			connectToRemoteDevice(device);
+	        
+		return true;
+	}
+	
+	public boolean disconnectAllDevices()
+	{
+		try 
+		{
+			for(String device : connectedDevices)
+			{
+				RemoteService.deviceToSocket.get(device).close();
+				deviceToOutput.get(device).close();
+	        }
+			RemoteService.deviceToSocket.clear();
+			deviceToOutput.clear();
+		}
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		
+		return true;
+	}
+	
+	public boolean addRemoteDevice(ArrayList<Integer> resources, String deviceIP)
+	{
+		if(!RemoteService.deviceToSocket.containsKey(deviceIP))
+			connectToRemoteDevice(deviceIP);
+		
+		for(int resource : resources)
+		{
+			if(resourceToOutput.get(resource) == null)
+				resourceToOutput.put(resource, new ArrayList<AppendingObjectOutputStream>());  
+		
+			resourceToOutput.get(resource).add(deviceToOutput.get(deviceIP));
+		}
+		return true;
+	}
+	
+	public boolean sendRequest(RemoteRequest request)
+	{
+		
+        return true;
+	}
+	
+	public void sendMotionEvent(MotionEvent event)
+	{
+		float x = event.getX();
+		float y = event.getY();
+		
+		RemoteMotionEvent rme = new RemoteMotionEvent(event.getDownTime(),
+				event.getEventTime(), x / Xdefault, y / Ydefault,
+				event.getAction(), event.getSource());
+
+		try 
+		{
+			for (AppendingObjectOutputStream output : resourceToOutput.get(Device.RESOURCE_TYPE_TOUCH))
+				output.writeObject(rme);
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	public void sendSensorEvent(RemoteSensorEvent rse)
+	{
+		try 
+		{
+			for (AppendingObjectOutputStream output : resourceToOutput.get(Device.RESOURCE_TYPE_SENSOR))
+				output.writeObject(rse);
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	public void sendLocation(Location location)
+	{
+		// TODO Auto-generated method stub
+		RemoteLocation RL = new RemoteLocation(location);
+		
+		try 
+		{
+			for (AppendingObjectOutputStream output : resourceToOutput.get(Device.RESOURCE_TYPE_LOCATION))
+				output.writeObject(RL);
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	public void sendMusicData(SdPackage MDtoSend)
+	{
+		try 
+		{
+			for (AppendingObjectOutputStream output : resourceToOutput.get(Device.RESOURCE_TYPE_AUDIO))
+				output.writeObject(MDtoSend);
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+
+	@Override
+	public void run() 
+	{
+		// TODO Auto-generated method stub
+		
+	}
+}
